/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.EsquemaOperacionalDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaOperacional;
import com.rjconsultores.ventaboletos.service.EsquemaOperacionalService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("esquemaOperacionalService")
public class EsquemaOperacionalServiceImpl implements EsquemaOperacionalService {

    @Autowired
    private EsquemaOperacionalDAO esquemaOperacionalDAO;

    public List<EsquemaOperacional> obtenerTodos() {
        return esquemaOperacionalDAO.obtenerTodos();
    }

    public EsquemaOperacional obtenerID(Integer id) {
        return esquemaOperacionalDAO.obtenerID(id);
    }

    @Transactional
    public EsquemaOperacional suscribir(EsquemaOperacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaOperacionalDAO.suscribir(entidad);
    }

    @Transactional
    public EsquemaOperacional actualizacion(EsquemaOperacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaOperacionalDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(EsquemaOperacional entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        esquemaOperacionalDAO.actualizacion(entidad);
    }

    public List<EsquemaOperacional> dentroVigenciaEsquemaOperacional(Date dataGeracao) {
        return esquemaOperacionalDAO.dentroVigenciaEsquemaOperacional(dataGeracao);
    }

    public List<EsquemaOperacional> dentroVigenciaEsquemaOperacional(Date dataDe, Date dataAte) {
        return esquemaOperacionalDAO.dentroVigenciaEsquemaOperacional(dataDe, dataAte);
    }
}
